export class TerminalSimulator {
    constructor(username, players) {
        this.currentPath = `F:\\Users\\${username}\\Terminal`
        this.existingPaths = [ `F:\\Users` ]
        this.rootDrive = "F:"
        this.admin = false
        this.getPlayers(players)
    }
    getPlayers(players) {
        for (const player of players) {
            this.existingPaths.push(
                `F:\\Users\\${player.name}`,
                `F:\\Users\\${player.name}\\Terminal`,
                `F:\\Users\\${player.name}\\Terminal\\Options`,
                `F:\\Users\\${player.name}\\Terminal\\Options\\Inventory`,
                `F:\\Users\\${player.name}\\Terminal\\settings`,
                `F:\\Users\\${player.name}\\Terminal\\Containers`
            )
        }
    }
    notRecognized(command) {
        return `§cThe term '${command}' is not recognized.§r`
    }
    executeCommand(i, command) {
        const commands = command.split(" ")
        if (command === "Admin true") {
            this.admin = true
            return { out: "§aYou are now temporarily an Admin", path: this.currentPath }
        }
        else if (!commands[0].startsWith("/")) {
            switch (commands[0]) {
                case "cd":
                    if (commands[1] && commands[1] === "..") {
                        const pathParts = this.currentPath.split("\\")
                        pathParts.pop()
                        const parentPath = pathParts.join("\\")
                        if (this.existingPaths.some(path => path.startsWith(parentPath)) && parentPath.startsWith(this.rootDrive)) {
                            this.currentPath = parentPath
                        }
                        else return { out: undefined, path: this.currentPath }
                    }
                    else if (commands[1] && commands[1].startsWith("./")) {
                        const folderName = commands.slice(1).join().replace(/,/g, " ").slice(2)
                        const newPath = `${this.currentPath}\\${folderName}`
                        if (this.existingPaths.includes(newPath.replace(/\//g, "\\"))) {
                            this.currentPath = newPath.replace(/\//g, "\\")
                        } else return { out: `§cCannot find path '${newPath}' because it does not exist`, path: this.currentPath }
                    }
                    else return { out: this.notRecognized(commands.join().replace(/,/g, "")), path: this.currentPath }
                    break
                case "cmd": return { out: `Storage Management Terminal §h\n[Version 1.0] [Minecraft 1.20.70+]\n§7(c) Effect99. All rights reserved`, path: this.currentPath }
                case "mkdir":
                    if (commands[1] && commands.slice(1).join().replace(/,/g, " ").replace(/[^a-zA-Z0-9\s]/g, '').length) {
                        const folderName = commands.slice(1).join().replace(/,/g, " ").replace(/[^a-zA-Z0-9\s]/g, '')
                        const newPath = `${this.currentPath}\\${folderName}`
                        if (this.existingPaths.includes(newPath)) return { out: `§cAn item with the specified name ${newPath} already exists.`, path: this.currentPath }
                        else {
                            this.existingPaths.push(newPath)
                            return { out: `§aLastWriteTime\n§r${new Date().toLocaleDateString()}  ${new Date().toLocaleTimeString()}\n§aLength Name§r\n${folderName}`, path: this.currentPath }
                        }
                    }
                    else return { out: this.notRecognized(commands[0]), path: this.currentPath }
                case "date": return { out: new Date().toDateString(), path: this.currentPath }
                default: return { out: commands[0] ? this.notRecognized(commands[0]) : '', path: this.currentPath }
            }
        }
        else if (this.admin && command.startsWith("/")) {
            const successful = i.source.dimension.runCommand(command.slice(1)).successCount
            return { out: `${successful ? `§aSuccessful Command` : `§cThe command was unsuccessful`}\n§7${command.slice(1)}`, path: this.currentPath }
        }
        else if (command.startsWith("/")) return { out: `§cYou are not authorized to run that command`, path: this.currentPath }
        return { out: undefined, path: this.currentPath }
    }
}